package interface_graphique;


import static common.Log.COMM;
import static common.Log.LOG_ON;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JRadioButton;

import org.apache.log4j.Level;

import common.FullDuplexMsgWorker;
import trivial.AnswersList;
import trivial.MessType;

/*
 * 
 */
/**
 * 
 * @author Éric Lallet.
 *
 */
public class CallBack implements MouseListener {
	/**
	 * Jpanel SWING où défilera le texte du tchat.
	 */
	private Texte texte;
	
	/**
	 * Pseudonyme de l'utilisateur.
	 */
	private String pseudo;
	/**
	 * Worker relié au serveur pour les échanges TCP.
	 */
	private FullDuplexMsgWorker worker;

	/**
	 * JButton du bouton pour valider les réponses.
	 */
	private JButton boutonValider;
	/**
	 * radio boutons des 4 propostions A, B, C , D.
	 */
	 private JRadioButton[] boutonsRadio;
	 /**
	  * JFrame contenant l'interface graphique.
	  */
	 private InterfaceGraphique fenetre;
	 
	/**
	 * Constructeur qui initialise les 4 champs de la classe, et met en place
	 * d'un listener sur le JTextField saisie.
	 *   
	 * @param interfaceGraphique
	 *                          JFrame SWING qui contient l'interface graphique.
	 */
	public CallBack(final InterfaceGraphique interfaceGraphique) {

		this.fenetre = interfaceGraphique;
		this.texte = interfaceGraphique.getTexte();
		this.pseudo = interfaceGraphique.getPseudo();
		this.worker = interfaceGraphique.getWorker();
		this.boutonsRadio = interfaceGraphique.getBoutonsRadio();
		this.boutonValider = interfaceGraphique.getBoutonValider();
		//this.saisie.addKeyListener(this);
		this.boutonValider.addMouseListener(this);
		
		System.out.println("tout est pret");
	}


	@Override
	public void mouseClicked(final MouseEvent arg0) {
		if (this.fenetre.isReponsePossible()) {
			String message;
			int num = -1;
			for (int ind = 0; ind < this.boutonsRadio.length; ind++) {
				if (this.boutonsRadio[ind].isSelected()) {
					num = ind;
					break;
				}
			}
			if (num == -1) {
				message = "Please select an answer before validating";
				this.texte.ecrireNouvelleLigne(message);
			} else {
				this.fenetre.setReponsePossible(false);
				char lettre = 'A';
				lettre += num;
				message = "You have validated the answer " + lettre;
				this.texte.ecrireNouvelleLigne(message);
				AnswersList answersList = new AnswersList(pseudo, num);
				try {
					if (LOG_ON && COMM.isEnabledFor(Level.TRACE)) {
						COMM.trace("Client --> " + answersList);
					}
					this.worker.sendMsg(MessType.ANSWERSLISTTYPE, answersList);
				} catch (IOException e) {
					e.printStackTrace();
				}
			}	
		}
	}





	@Override
	public void mouseEntered(final MouseEvent arg0) {
		
	}





	@Override
	public void mouseExited(final MouseEvent arg0) {
			
	}





	@Override
	public void mousePressed(final MouseEvent arg0) {
		
		
	}





	@Override
	public void mouseReleased(final MouseEvent arg0) {
	
		
	}

	
}
