package json;

import com.google.gson.Gson;

/**
 * 
 * @author Éric Lallet.
 *
 */
public class TrivialJson {
	/**
	 * 
	 */
	private static final String VOIDQUESTION = "{\"response_code\":0,\"results\":[{\"category\":\"void\",\"type\":\"multiple\",\"difficulty\":\"void\","
			+ "\"question\":\"Please wait for the next question\",\"correct_answer\":\"void\",\"incorrect_answers\":[\"void\",\"void\",\"void\"]}]}";
	/**
	 * json parser.
	 */
	private Gson gson;

	/**
	 * java class matching to the structure of the json response.
	 */
	private Response response;

	/**
	 * randomized trivial question.
	 */
	private TrivialQuestion trivialQuestion;

	

	/**
	 * 
	 * @param jsonStr
	 *               the json string to be parsed.
	 */
	public TrivialJson(final String jsonStr) {
		gson = new Gson();
		response = gson.fromJson(jsonStr, Response.class);
		setTrivialQuestionAndCorrectAnwser();
	}
	
	/**
	 * constructor for void question (text of question saying to wait for the next question).
	 */
	public TrivialJson() {
		gson = new Gson();
		response = gson.fromJson(VOIDQUESTION, Response.class);
		setTrivialQuestionAndCorrectAnwser();
	}
	

	/**
	 * create the randomized question, and set the correct answer.
	 */
	private void setTrivialQuestionAndCorrectAnwser()  {
		String[] anwsers = new String[TrivialQuestion.NBANSWERS];
		int correctAnswerNum = (int) (Math.random() * TrivialQuestion.NBANSWERS);
		for (int ind = 0, num = 0; ind < TrivialQuestion.NBANSWERS; ind++) {
			if (ind == correctAnswerNum) {
				anwsers[ind] = response.getCorrectAnswer();
			} else {
				anwsers[ind] = response.getIncorrectAnswer(num);
				num++;
			}
		}
		trivialQuestion = new TrivialQuestion(response.getCategory(), response.getDifficulty(), response.getQuestion(), anwsers, correctAnswerNum);

	}

	/**
	 * 
	 * @return
	 *        the randomized question.
	 */
	public TrivialQuestion getTrivialQuestion() {
		return trivialQuestion;
	}
}
