package trivial;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * 
 * @author Éric Lallet.
 *
 */
public class AnswersList implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 *
	 */
	
	
	/**
	 * List of answers.
	 */
	private List<Anwser> answersList;
	
	/**
	 * number of the correct answer.
	 */
	private int correctAnswer = -1;
	
	/**
	 * Create an empty answers list.
	 */
	public AnswersList() {
		answersList = new ArrayList<Anwser>();
	}
	
	/**
	 * Create a new answers list and add one answer.
	 * @param nickname
	 *             player nickname of the added answer. 
	 * @param num
	 *           num value of the added answer.
	 */
	public AnswersList(final String nickname, final int num) {
		answersList = new ArrayList<Anwser>();
		this.add(nickname, num);
	}
	
	/**
	 * 
	 * @return
	 *        number of the correct answer.
	 */
	public int getCorrectAnswer() {
		return correctAnswer;
	}

	/**
	 * 
	 * @param correctAnswer
	 *           number of the correct answer.
	 */
	public void setCorrectAnswer(final int correctAnswer) {
		this.correctAnswer = correctAnswer;
	}

	/**
	 * add one element to the answers list.
	 * @param nickname
	 *        player nickname of the added answer.
	 * @param num
	 *        num value of the added answer.
	 */
	public void add(final String nickname, final int num) {
		answersList.add(new Anwser(nickname, num));
	}
	
	/**
	 * 
	 * @param num
	 *        position in the answers list.
	 * @return
	 *        player nickname of the answer at the num position in the answers list. 
	 */
	public String getNickname(final int num) {
		return answersList.get(num).getNickName();
	}
	/**
	 * 
	 * @param num
	 *          position in the answers list.
	 * @return
	 *        num value of the answer at the num position in the answers list. 
	 */
	public int getAnswerNum(int num) {
		return answersList.get(num).getAnwserNum();
	}
	
	/**
	 * 
	 * @return
	 *        size of the answers list.
	 */
	public int getNbAnswers() {
		return answersList.size();
	}
	
	
	@Override
	public String toString() {
		String res =null;
		char letter = 'A';
		int numberOfanswer = answersList.size();
		letter += correctAnswer;
		res = "The correct answer was " + letter + "\n";
		res += numberOfanswer  + " player(s) have sent an answer: \n";
		for (int ind = 0; ind < numberOfanswer  ; ind++) {
			letter = 'A';
			letter += getAnswerNum(ind);
			res += getNickname(ind) + ": " + letter + ", ";
		}
		res += "\n";
		return res;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((answersList == null) ? 0 : answersList.hashCode());
		result = prime * result + correctAnswer;
		return result;
	}

	@Override
	public boolean equals(final Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		AnswersList other = (AnswersList) obj;
		if (answersList == null) {
			if (other.answersList != null) {
				return false;
			}
		} else if (!answersList.equals(other.answersList)) {
			return false;
		}
		if (correctAnswer != other.correctAnswer) {
			return false;
		}
		return true;
	}
}
