package https;

import static common.Log.LOGGER_NAME_TEST;
import static common.Log.LOG_ON;
import static common.Log.TEST;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.io.IOException;
import java.nio.ByteBuffer;

import org.apache.log4j.Level;
import org.junit.Ignore;
import org.junit.Test;

import common.Log;

public class TestRecv {
	//@Ignore
	@Test
	public void testRecv() throws Exception {
		Log.configureALogger(LOGGER_NAME_TEST, Level.TRACE);
		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("starting tests of recvData");
		}

		String beginingOfString = "{\"response_code\":0,\"results\":[{\"category\"";
		int begLen = beginingOfString.length();
		String endOfString = "]}]}";
		int endLen = endOfString.length();

		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("Test  recvData: SSL negociation");
		}
		HttpsProtocol https = new HttpsProtocol();

		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("Test  recvData: connexion");
		}
		https.connectTo("https://opentdb.com/api.php?amount=1&type=multiple&encode=url3986");
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("Test  recvData: recvData");
		}
		String body = https.recvData();

		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("Test  recvData: check data -> not null");
		}
		
		assertTrue("String not null", body != null);

		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("Test  recvData: check data -> not empty");
		}
		assertTrue("String not empty", body.length() != 0);

		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("Test  recvData: check data -> begining");
		}
		assertEquals("Begining of string", body.substring(0, begLen), beginingOfString );

		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("Test  recvData: check data -> end");
		}
		assertEquals("End of string", body.substring(body.length()-endLen, body.length()), endOfString );


		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("Test  recvData: check status");
		}
		assertTrue("Status Connected", https.getStatus() == Status.NotConnected);

		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("Test  recvData: should be closed");
		}
		body = https.recvData();
		assertTrue("null body", body == null);

		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("end of tests of recvData");
		}

	}

	//@Ignore
	@Test (expected = IOException.class)
	public void testChannel() throws IOException {
		Log.configureALogger(LOGGER_NAME_TEST, Level.TRACE);
		
		ByteBuffer buff = ByteBuffer.allocate(1024);
		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("starting more tests of recvData");
		}
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("Test  recvData: SSL negociation");
		}
		HttpsProtocol https = new HttpsProtocol();

		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("Test  recvData: connexion");
		}
		https.connectTo("https://opentdb.com/api.php?amount=1&type=multiple&encode=url3986");
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("Test  recvData: recvData");
		}
		https.recvData();

		
		

		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing use of channel");
		}

		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("Test  recvData: should be closed");
		}
		https.getHttpChan().read(buff);

		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("End of additional tests of recvData ");
		}
	}

}
